﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
#End Region

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private ctxt As JavaObject
	Private Storage As ExternalStorage
	Private Chooser As ContentChooser
	Private PCLV As PreoptimizedCLV
	Private CLV1 As CustomListView
	Private Jb As HttpJob
	Private CF As CheckBox
	Private JukeBox As SimpleExoPlayerView
	Private streamer As AudioStreamer
	Private Player1 As SimpleExoPlayer
	Private TTS1 As TTS
	Private recordingStart, playingstart As Long
	Private buffers As List
	Private timer1, timer2 As Timer
	Private ClipTime, nf As Int
	Private mBitRate As Int = 16
	Private mSampleRate As Int = 22050
	Private mMono As Boolean = True
	Dim Entete1, Entete2, FileList, HideList, Record, Label1, Label2, Label3 As B4XView
	Dim btnSR, btnPlay, btnSave, btnStop, MusicTitle As B4XView
	Public FileName As String
	Private rp As RuntimePermissions
	Private cStoragePath, DestinationFile, FolderStack As ExternalFile
	Private IN As InputStream, OUT As OutputStream
	Public StartUp As Boolean = False
	Private FoldersStack As List
	Private UpItem As ExternalFile
	Public SongName, SongLineName As String
	Public FirstTime As Boolean = False
	Public ListSongName As List
	Public MP As MediaPlayer
	Public mFileName, rFileName As String
	Private Output As OutputStream
	Private Recording As Boolean
	Private ClipTime As Int
	Private NewFileName(20) As String
	
End Sub

Public Sub Initialize
	streamer.Initialize("streamer", mSampleRate, mMono, mBitRate, streamer.VOLUME_MUSIC)
	Storage.Initialize(Me,"Storage")
	Jb.Initialize("",Me)
	CF.Initialize("")
	buffers.Initialize
	Player1.Initialize("Player")
	timer1.Initialize("timer1", 1000)
	timer2.Initialize("timer2", 1000)
	FolderStack.Initialize
	Chooser.Initialize("chooser") 
	If TTS1.IsInitialized = False Then
		TTS1.Initialize("TTS1")
	End If
End Sub

Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("Music")
	PCLV.Initialize(Me, "PCLV", CLV1)
	FoldersStack.Initialize
	ctxt.InitializeContext
	MP.Initialize2("MP")
	Depart
End Sub


Private Sub Depart
	Msgbox2Async("Voulez vous créer un nouveau dossier pour les enregistrements sonores ? Si c'est déjà fait et que vous ne voulez pas changer, répondez NON !", "Créer un nouveau dossier ?", "Oui", "", "Non", Null, True)
	Wait For Msgbox_Result (Result As Int)
	If Result=DialogResponse.POSITIVE Then
		CreateNewDir
	Else
		FirstTime = False
		FileList_Click
	End If
End Sub

Sub CreateNewDir
	MusicTitle.Text="Attendez s'il vous plaît le téléchargement et la copie de tous les fichiers musicaux"
	Storage.SelectDir(CF.Checked)
	Wait For Storage_ExternalFolderAvailable
	' Trouver et confirmer  le dossier existant (déjà créé) sur le stockage externe OU le choisir et le créer lors de la première utilisation
	' Vous pouvez très bien supprimer manuellement ce dossier à l'extérieur de cette application ou renommer, effacer, ajouter des enregistrements sonores
	' Par contre, si vous avez supprimé le dossier initialement créé pour ette application, il faudra en recréer un autre A PARTIR de cette application pour qu'il soit reconnu ensuite !
	cStoragePath = Storage.Root
		
	'Copie d'un fichier témoin (CookieFile.txt) dans le dossier choisi sur le stockage externe
		
	FileName = "CookieFile.txt"
	CopyFileToExternalStorage(File.DirAssets, FileName, Storage.root, "")
	Log (FileName & " a été créé")
	' Téléchargement et copie de plus de dix fichiers musicaux dans le dossier choisi par l'utilisateur
	Log("Téléchargement des fichiers et copie sur le stockage externe")
	ListSongName.Initialize
	ListSongName = File.ReadList(File.DirAssets, "FilesList.txt")
	For i= 0 To ListSongName.Size -1
		Log (i)
		Log(ListSongName.Size)
	NewFileName(i)=ListSongName.Get(i)
		Log(NewFileName(i))
	
		FileName= NewFileName (i)
		Jb.Download("https://www.marcalaindaniel.fr/MusicBoxPlayer/"& FileName)
		Jb.GetRequest.Timeout = 100000
		wait for (Jb)Jobdone
		If Jb.Success Then
			Log("Bonne nouvelle ! Le téléchargement a réussi pour : " & FileName)
			IN = Jb.GetInputStream
			DestinationFile = Storage.CreateNewFile(cStoragePath, FileName)
			OUT = Storage.OpenOutputStream(DestinationFile)
			File.Copy2(IN, OUT)
			OUT.Close
			IN.Close
			Jb.release
			nf = i + 1
			MusicTitle.Text="Patience en attendant que le fichier musical " & nf & " sur 14 soit téléchargé."
			MusicTitle.Text = MusicTitle.Text & CRLF & FileName & " a été téléchargé avec succès"
		Else
			Log("Mauvaise nouvelle ! Le téléchargement a échoué pour : " & FileName)
		End If
	Next
		
	Sleep(9000)
	MusicTitle.Text = ""
	MsgboxAsync("Félicitations, vous avez créé avec succès votre dossier pour les enregistrements sonores, 14 fichiers musicaux ont bien été téléchargés.","Choix du dossier par l'utilisateur")
	FirstTime = True
	FileList_Click
End Sub


Public Sub CopyFileToExternalStorage (Dir As String, Name As String, Parent As ExternalFile, Rename As String) As Boolean
   If File.Exists(Dir, FileName) = False Then
        Log("Mauvaise nouvelle ! Ce fichier n'a pas été trouvé ou n'existe pas et n'a pas pu être copié: " & FileName)
        Return False
    End If
	Log("Bonne nouvelle ! Le fichier suivant a bien été copié dans le dossier que vous avez créé: " & FileName)
    Dim iStream As InputStream, oStream As OutputStream
    Dim oFile As ExternalFile
 
    If Rename <> "" Then
        oFile = Storage.FindFileOrCreate(Parent, "")  ' Renommer le fichier sortant avec ""  / Remplacer "" par le nom du fichier original si vous souhaitez le conserver
    Else
        oFile = Storage.FindFileOrCreate(Parent, Name)
    End If
 
    If oFile.IsInitialized Then
        iStream = File.OpenInput(Dir, FileName)
        oStream = Storage.OpenOutputStream(oFile)
        File.copy2(iStream, oStream)
        iStream.Close
        oStream.Close
        Return True
    Else
        Log("Impossible de copier ce fichier dans le nouveau dossier: " & FileName)
        Return False
    End If
End Sub




Private Sub Timer1_Tick
	Label1.Text = "Enregistrement: " & _
		Round((DateTime.Now - recordingStart) / DateTime.TicksPerSecond) & " secondes"
End Sub

Private Sub Timer2_Tick
	Label1.Text = "Lecture: " & _
		Round((DateTime.Now - playingstart) / DateTime.TicksPerSecond)& " sur " & ClipTime & " secondes"
End Sub

Private Sub EnterFolder (folder As ExternalFile)
	Dim n As Int
	ListSongName.Initialize
	FoldersStack.Clear
	CLV1.Clear
	If FoldersStack.Size > 1 Then
		CLV1.DefaultTextBackgroundColor=(xui.Color_White)
		CLV1.AddTextItem("..", UpItem)
	End If
	For Each f As ExternalFile In Storage.ListFiles(folder)
		n = n + 1
		If f.IsFolder Then
		Else If IsMusicFile(f.Name) Then
			Dim cs As CSBuilder
			cs.Initialize.Append(f.Name).PopAll
			ListSongName.Add(f.Name)
			Log (f.Name)
			CLV1.AddTextItem(cs, f)
		End If
	Next
	CLV1.DefaultTextBackgroundColor=(xui.Color_Cyan)
	CLV1.AddTextItem("  CLIQUEZ ICI POUR ÉCOUTER TOUTE LA LISTE " , "")
	PCLV.Commit
	PCLV.B4XSeekBar1.Value = CLV1.Size - 1
End Sub

Sub CLV1_ItemLongClick(Index As Int, Value As Object)
	Dim MusicGenre As Int
	If Index = CLV1.Size -1 Then
		PlayALLPlayList
	Else
	
	Dim MusicGenre As Int
	Dim suffix As String, ls As Int
	SongName = ListSongName.Get(Index)
	CLV1.GetPanel(Index).Color = xui.Color_Yellow
	Storage.FindFile(Storage.Root,SongName)
	ls = SongName.length
	suffix = SongName.SubString2(ls-3, ls)
	Log ("Suffix = " & suffix)
	Log ("File Name = " & SongName)
	
	If SongName.EndsWith(".aac") Or SongName.EndsWith(".AAC")Then MusicGenre = 1
	If SongName.EndsWith(".flac") Or SongName.EndsWith(".FLAC")Then MusicGenre = 1
	If SongName.EndsWith(".mp3") Or SongName.EndsWith(".MP3")Then MusicGenre = 1
	If SongName.EndsWith(".mp4") Or SongName.EndsWith(".MP4")Then MusicGenre = 1
	If SongName.EndsWith(".mkv") Or SongName.EndsWith(".MKV")Then MusicGenre = 1
	If SongName.EndsWith(".wav") Or SongName.EndsWith(".WAV")Then MusicGenre = 1
	
	If SongName.EndsWith(".mid") Or SongName.EndsWith(".MID") Or SongName.EndsWith("MIDI") Then MusicGenre = 2
	If SongName.EndsWith(".gp3") Then MusicGenre = 3
	
	
	Select MusicGenre
		Case 1
			'Lecture des fichiers musicaux dans l'application
			If File.Exists(File.DirInternal, SongName) = False Then
				Dim iStream As InputStream, oStream As OutputStream
				Dim oFile As ExternalFile

				oFile = Storage.FindFileOrCreate(Storage.Root, SongName)

				If oFile.IsInitialized Then
					iStream = Storage.OpenInputStream(oFile)
					oStream = File.OpenOutput(File.DirInternal, SongName, False)
					File.copy2(iStream, oStream)
					iStream.Close
					oStream.Close
				End If
			End If
			Player1.Prepare(Player1.CreateFileSource(File.DirInternal,SongName))
			JukeBox.Player = Player1
			MusicTitle.Text = " Lecture en cours de " & SongName
			Player1.Play
			
		
		Case Else
			
			'Lecture des fichiers musicaux non acceptés en dehors de l'application par vos propres dispositifs s'ils sont existants et disponibles
			
			Chooser.Show("audio/*", "Choose audio file")
			Wait For Chooser_Result (Success1 As Boolean, Dir1 As String, FileName1 As String)
			If Success1 Then
				Dim InStr As InputStream = File.OpenInput("ContentDir",FileName1)
				Dim OutStr As OutputStream = File.OpenOutput(File.DirInternal, SongName,False)
				File.Copy2(InStr,OutStr)
				OutStr.Close
			Else
				MsgboxAsync("Si votre fichier musical n'est pas reconnu," & CRLF & "vous pouvez l'ouvrir directement à l'extérieur" & CRLF & "de cette application en ouvrant le dossier"& CRLF & "choisi par vous sur le stockage externe","Avis")
			End If
		
	End Select
	End If
End Sub


Private Sub IsMusicFile (Name As String) As Boolean
	Dim n As String = Name.ToLowerCase
	For Each extension As String In Array("aac", "AAC", "3gp", "mkv", "MKV","mp3", "MP3", "mp4", "MP4", "flac", "FLAC", "mid", "MID", "wav", "WAV", "Wav")
		If n.EndsWith(extension) Then Return True
	Next
	Return False
End Sub

Sub StartWaveFile(Dir3 As String, FileName3 As String, SampleRate As Int, Mono As Boolean _
		, BitsPerSample As Int) As OutputStream
	File.Delete(Dir3, FileName3)
	Dim raf As RandomAccessFile
	raf.Initialize2(Dir3, FileName3, False, True)
	raf.WriteBytes("RIFF".GetBytes("ASCII"), 0, 4, raf.CurrentPosition)
	raf.CurrentPosition = 8 'skip 4 bytes for the size
	raf.WriteBytes("WAVE".GetBytes("ASCII"),0, 4, raf.CurrentPosition)
	raf.WriteBytes("fmt ".GetBytes("ASCII"),0, 4, raf.CurrentPosition)
	raf.WriteInt(16, raf.CurrentPosition)
	raf.WriteShort(1, raf.CurrentPosition)
	Dim numberOfChannels As Int
	If Mono Then numberOfChannels = 1 Else numberOfChannels = 2
	raf.WriteShort(numberOfChannels, raf.CurrentPosition)
	raf.WriteInt(SampleRate, raf.CurrentPosition)
	raf.WriteInt(SampleRate * numberOfChannels * BitsPerSample / 8, raf.CurrentPosition)
	raf.WriteShort(numberOfChannels * BitsPerSample / 8, raf.CurrentPosition)
	raf.WriteShort(BitsPerSample, raf.CurrentPosition)
	raf.WriteBytes("data".GetBytes("ASCII"),0, 4, raf.CurrentPosition)
	raf.WriteInt(0, raf.CurrentPosition)
	raf.Close
	Return File.OpenOutput(Dir3, FileName3, True)
End Sub

Sub CloseWaveFile(Dir4 As String, FileName4 As String)
	Dim raf As RandomAccessFile
	raf.Initialize2(Dir4, FileName4, False, True)
	raf.WriteInt(raf.Size - 8, 4)
	raf.WriteInt(raf.Size - 44, 40)
	raf.Close
End Sub

Sub streamer_RecordBuffer (Buffer() As Byte)
	If Recording Then Output.WriteBytes(Buffer, 0, Buffer.Length)
	'the above check is required as the last message will arrive after we call StopRecording.
End Sub

Sub Record_Click
	Root.RemoveAllViews
	Root.LoadLayout("Recorder")
	Label2.Text = "▲ Démarrer et arrêtez ▲ " & CRLF & "un enregistrement sonore"
	Label3.Text = "Vous pouvez enregistrer un son avec les" & CRLF & "deux touches ci-dessus. Ensuite, vous"
	Label3.Text = Label3.Text & CRLF & "pouvez écouter cet enregistrement" & CRLF & "provisoire et, si vous êtes satisfait(e), vous"
	Label3.Text = Label3.Text & CRLF & "pouvez l'enregistrer définitivement dans" & CRLF & " le dossier que vous avez créé au départ."
End Sub

Sub FileList_Click
	MusicTitle.Text ="APPUI PROLONGÉ sur le titre du fichier" & CRLF & " sonore que vous souhaitez écouter."
	CLV1.Clear
	PCLV.NumberOfSteps = 5
	PCLV.lblHint.Font = xui.CreateDefaultBoldFont(20)
	PCLV.lblHint.TextColor = xui.Color_Blue
	PCLV.ShowScrollBar = False
		If FirstTime = True Then
		EnterFolder(cStoragePath)
	Else
		Storage.SelectDir(True)
		Wait For Storage_ExternalFolderAvailable
		If (Storage.Root.IsFolder And Storage.Root.Name <> "")Then
			EnterFolder(Storage.Root)
		End If
	End If	
	HideList.Enabled = True
End Sub

Sub HideList_Click
	MusicTitle.Text ="BIENVENUE DANS VOTRE DISCOTHÈQUE !"
	CLV1.Clear
	PCLV.Initialize(Me, "PCLV", CLV1)
	CLV1.DefaultTextBackgroundColor=(xui.Color_White)
End Sub

Private Sub PlayALLPlayList
	Msgbox2Async("Voulez-vous réellement écouter la totalité des fichiers sonores ? Veuillez noter que si vous avez enregistré plusieurs dizaines de fichiers musicaux dans le dossier créé pour cette application, vous devrez attendre quelques secondes pendant le chargement de la PlayList.", "Ecouter la PLAYLIST", "Oui", "", "Non", Null, True)
	Wait For Msgbox_Result (Result As Int)
	If Result=DialogResponse.POSITIVE Then
		Player1.Release
		Player1.Initialize("Player")
		Dim Sources As List
		Sources.Initialize
		For nf = 0 To ListSongName.Size -1
			SongName = ListSongName.Get(nf)
			Storage.FindFile(Storage.Root,SongName)
			If File.Exists(File.DirInternal, SongName) = False Then
				Dim iStream As InputStream, oStream As OutputStream
				Dim oFile As ExternalFile
				oFile = Storage.FindFileOrCreate(Storage.Root, SongName)
				If oFile.IsInitialized Then
					iStream = Storage.OpenInputStream(oFile)
					oStream = File.OpenOutput(File.DirInternal, SongName, False)
					File.copy2(iStream, oStream)
					iStream.Close
					oStream.Close
				End If
			End If
			Sources.Add(Player1.CreateFileSource(File.DirInternal,SongName))
		Next
		Player1.Prepare(Player1.CreateListSource(Sources))
		JukeBox.Player = Player1
		Player1.Play
		MusicTitle.Text = "Vous êtes en train d'écouter la totalité" & CRLF & " de la PLAYLIST enregistrée dans le dossier créé !"
	End If
End Sub

Sub btnSR_Click
	btnStop.Enabled = True
	rp.CheckAndRequest(rp.PERMISSION_RECORD_AUDIO)
	Wait For B4XPage_PermissionResult (Permission As String, Result As Boolean)
	If Result = False Then
		xui.MsgboxAsync("Permission refusée", "")
		Return
	Else
		mFileName = DateTime.GetYear(DateTime.Now) & "-" & DateTime.GetMonth(DateTime.Now) & "-" & DateTime.GetDayOfMonth(DateTime.Now)
		mFileName = mFileName & "-" & DateTime.Gethour(DateTime.Now) & "h" & DateTime.GetMinute(DateTime.Now) & ".wav"
		buffers.Clear
		Output = StartWaveFile(File.DirInternal, mFileName, mSampleRate, mMono, mBitRate)
		Recording = True
		streamer.StartRecording
		recordingStart = DateTime.Now
		timer1.Enabled = True
		Timer1_Tick
		btnPlay.Enabled = False
		btnSR.Enabled = False
	End If
End Sub

Sub btnStop_Click
	ClipTime =(( DateTime.Now - recordingStart) / DateTime.TicksPerSecond)
	streamer.StopRecording
	Recording = False
	Output.Close
	CloseWaveFile(File.DirInternal, mFileName)
	timer1.Enabled = False
	btnPlay.Enabled = True
	Label1.Text = ""
	btnPlay.Enabled = True
	btnPlay.Visible= True
	btnStop.Enabled = False
	btnSR.Enabled = True
End Sub

Private Sub btnPlay_Click
	MP.Load(File.DirInternal, mFileName)
	playingstart = DateTime.now
	timer2.Enabled = True
	Timer2_Tick
	MP.Play
	btnSave.Enabled = True
	btnSave.Visible= True
End Sub

Sub mp_Complete
	timer2.Enabled = False
	Log("PlaybackComplete")
	btnSR.Enabled = True
End Sub

Sub BtnSave_Click
	Msgbox2Async("Confirmez-vous l'enregistrement de ce fichier sonore?", "Enregistrer ce son", "Oui", "", "Non", Null, True)
	Wait For Msgbox_Result (Result As Int)
	If Result=DialogResponse.POSITIVE Then
		mFileName = DateTime.GetYear(DateTime.Now) & "-" & DateTime.GetMonth(DateTime.Now) & "-" & DateTime.GetDayOfMonth(DateTime.Now)
		mFileName = mFileName & "-" & DateTime.Gethour(DateTime.Now) & "h" & DateTime.GetMinute(DateTime.Now) & ".wav"
		FileName = mFileName
		CopyFileToExternalStorage(File.DirInternal, FileName, Storage.root, "")
		btnPlay.Visible=False
		btnSave.Visible = False
		Label1.Text = "Enregistrement de " & FileName & " dans le dossier choisi."
		Sleep(6000)
		Label1.Text = "Pour vérifier si ce fichier a bien été enregistré," & CRLF & "retournez à la Discothèque" & CRLF & "et affichez la liste des fichiers."
		Sleep(6000)
		Label1.Text = ""
	End If
End Sub

Sub BtnReturn_Click
	Root.RemoveAllViews
	Root.LoadLayout("Music")
	FileList_Click
End Sub
